(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-angularcommons-core'), require('rxjs'), require('tscommons-core'), require('@angular/common'), require('ngx-angularcommons-browser'), require('ngx-angularcommons-pipe'), require('ngx-webappcommons-core'), require('ngx-webappcommons-form')) :
    typeof define === 'function' && define.amd ? define('ngx-webappcommons-table', ['exports', '@angular/core', 'ngx-angularcommons-core', 'rxjs', 'tscommons-core', '@angular/common', 'ngx-angularcommons-browser', 'ngx-angularcommons-pipe', 'ngx-webappcommons-core', 'ngx-webappcommons-form'], factory) :
    (global = global || self, factory(global['ngx-webappcommons-table'] = {}, global.ng.core, global['ngx-angularcommons-core'], global.rxjs, global['tscommons-core'], global.ng.common, global['ngx-angularcommons-browser'], global['ngx-angularcommons-pipe'], global['ngx-webappcommons-core'], global['ngx-webappcommons-form']));
}(this, (function (exports, core, ngxAngularcommonsCore, rxjs, tscommonsCore, common, ngxAngularcommonsBrowser, ngxAngularcommonsPipe, ngxWebappcommonsCore, ngxWebappcommonsForm) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var CommonsTable2Service = /** @class */ (function () {
        function CommonsTable2Service() {
            this.onColumnsChanged = new Map();
            this.onSelectable = new Map();
            this.selectable = new Map();
            this.onDisabled = new Map();
            this.disabled = new Map();
        }
        CommonsTable2Service.prototype.registerTable = function (component) {
            this.onColumnsChanged.set(component, new rxjs.ReplaySubject(1));
            this.onSelectable.set(component, new rxjs.ReplaySubject(1));
            this.selectable.set(component, undefined);
            this.onDisabled.set(component, new rxjs.ReplaySubject(1));
            this.disabled.set(component, false);
        };
        CommonsTable2Service.prototype.columnsChangedObservable = function (component) {
            if (!this.onColumnsChanged.has(component))
                throw new Error('Unregistered table');
            return this.onColumnsChanged.get(component);
        };
        CommonsTable2Service.prototype.cascadeColumnsChanged = function (component, columns) {
            if (!this.onColumnsChanged.has(component))
                throw new Error('Unregistered table');
            this.onColumnsChanged.get(component).next(columns);
        };
        CommonsTable2Service.prototype.selectableObservable = function (component) {
            if (!this.onSelectable.has(component))
                throw new Error('Unregistered table');
            return this.onSelectable.get(component);
        };
        CommonsTable2Service.prototype.cascadeSelectable = function (component, selectable) {
            if (!this.onSelectable.has(component))
                throw new Error('Unregistered table');
            this.selectable.set(component, selectable);
            this.onSelectable.get(component).next(selectable);
        };
        CommonsTable2Service.prototype.getSelectable = function (component) {
            if (!this.selectable.has(component))
                throw new Error('Unregistered table');
            return this.selectable.get(component);
        };
        CommonsTable2Service.prototype.disabledObservable = function (component) {
            if (!this.onSelectable.has(component))
                throw new Error('Unregistered table');
            return this.onDisabled.get(component);
        };
        CommonsTable2Service.prototype.cascadeDisabled = function (component, disabled) {
            if (!this.onDisabled.has(component))
                throw new Error('Unregistered table');
            this.disabled.set(component, disabled);
            this.onDisabled.get(component).next(disabled);
        };
        CommonsTable2Service.prototype.getDisabled = function (component) {
            if (!this.disabled.has(component))
                throw new Error('Unregistered table');
            return this.disabled.get(component);
        };
        CommonsTable2Service = __decorate([
            core.Injectable()
        ], CommonsTable2Service);
        return CommonsTable2Service;
    }());

    var CommonsTable2Columns = /** @class */ (function () {
        function CommonsTable2Columns() {
        }
        CommonsTable2Columns.listColumns = function (contentChildren) {
            if (!contentChildren)
                return [];
            var columns = contentChildren
                .map(function (child) { return ({
                name: child.name,
                width: child.width
            }); });
            return columns;
        };
        CommonsTable2Columns.getGridTemplateColumns = function (columns) {
            var widths = columns
                .map(function (column) { return column.width || '1fr'; });
            return widths.join(' ');
        };
        return CommonsTable2Columns;
    }());

    var CommonsTable2HeaderColumnComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2HeaderColumnComponent, _super);
        function CommonsTable2HeaderColumnComponent(ref) {
            var _this = _super.call(this) || this;
            _this.ref = ref;
            return _this;
        }
        CommonsTable2HeaderColumnComponent.prototype.ngAfterContentInit = function () {
            if (!this.title)
                this.title = this.ref.nativeElement.innerText;
        };
        CommonsTable2HeaderColumnComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.HostBinding('title'), core.Input()
        ], CommonsTable2HeaderColumnComponent.prototype, "title", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2HeaderColumnComponent.prototype, "name", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2HeaderColumnComponent.prototype, "width", void 0);
        CommonsTable2HeaderColumnComponent = __decorate([
            core.Component({
                selector: '[commons-table2-header-column]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block;text-align:left;box-sizing:border-box;padding:0 16px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-family:Roboto;font-weight:500;font-size:14px;line-height:21px}"]
            })
        ], CommonsTable2HeaderColumnComponent);
        return CommonsTable2HeaderColumnComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2BodyComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2BodyComponent, _super);
        function CommonsTable2BodyComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommonsTable2BodyComponent = __decorate([
            core.Component({
                selector: '[commons-table2-body]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block}"]
            })
        ], CommonsTable2BodyComponent);
        return CommonsTable2BodyComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2Component = /** @class */ (function (_super) {
        __extends(CommonsTable2Component, _super);
        function CommonsTable2Component(service) {
            var _this = _super.call(this) || this;
            _this.service = service;
            _this.disabled = false;
            // these have to be public so that the other component classes can access them
            _this.columns = [];
            _this.service.registerTable(_this);
            return _this;
        }
        CommonsTable2Component.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.service.cascadeSelectable(this, this.selectable);
            this.service.cascadeDisabled(this, this.disabled);
        };
        CommonsTable2Component.prototype.ngOnChanges = function (changes) {
            if (changes.selectable && changes.selectable.currentValue !== changes.selectable.previousValue) {
                this.service.cascadeSelectable(this, this.selectable);
            }
            if (changes.disabled && changes.disabled.currentValue !== changes.disabled.previousValue) {
                this.service.cascadeDisabled(this, this.disabled);
            }
        };
        CommonsTable2Component.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.subscribe(this.columnsContentChildren.changes, function () {
                _this.refreshColumns();
            });
            this.refreshColumns();
        };
        CommonsTable2Component.prototype.refreshColumns = function () {
            this.columns = CommonsTable2Columns.listColumns(this.columnsContentChildren);
            this.service.cascadeColumnsChanged(this, this.columns);
        };
        CommonsTable2Component.ctorParameters = function () { return [
            { type: CommonsTable2Service }
        ]; };
        __decorate([
            core.ContentChildren(CommonsTable2HeaderColumnComponent, { descendants: true })
        ], CommonsTable2Component.prototype, "columnsContentChildren", void 0);
        __decorate([
            core.ContentChildren(CommonsTable2BodyComponent)
        ], CommonsTable2Component.prototype, "bodyContentChildren", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2Component.prototype, "selectable", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2Component.prototype, "disabled", void 0);
        CommonsTable2Component = __decorate([
            core.Component({
                selector: '[commons-table2]',
                template: "<ng-content></ng-content>\n",
                styles: ["@charset 'utf8';:host{display:block;box-sizing:border-box;width:100%;border:1px solid #000;margin:0;padding:0;border-collapse:collapse;border-spacing:0;border-radius:4px;font-family:Roboto}:host /deep/ tr{border-top-style:solid;border-top-width:1px}:host /deep/ thead>tr:first-child{border-top:none}:host-context(body.webappcommons-theme-blue.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-blue.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-blue.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-blue.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-darkred.theme-light){border-color:#383838;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred.theme-dark){border-color:#afafaf;color:#474747}:host-context(body.webappcommons-theme-darkred.theme-light) /deep/ tr{border-top-color:#383838}:host-context(body.webappcommons-theme-darkred.theme-dark) /deep/ tr{border-top-color:#afafaf}:host-context(body.webappcommons-theme-hotpink.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-hotpink.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-hotpink.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-hotpink.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-marine.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-marine.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-marine.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-marine.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-muted.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-muted.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-muted.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-muted.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-night.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-night.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-night.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-night.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-patrolred.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-patrolred.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-patrolred.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-patrolred.theme-dark) /deep/ tr{border-top-color:#404040}:host-context(body.webappcommons-theme-purple.theme-light){border-color:#e0e0e0;color:#333}:host-context(body.webappcommons-theme-purple.theme-dark){border-color:#404040;color:#ccc}:host-context(body.webappcommons-theme-purple.theme-light) /deep/ tr{border-top-color:#e0e0e0}:host-context(body.webappcommons-theme-purple.theme-dark) /deep/ tr{border-top-color:#404040}"]
            })
        ], CommonsTable2Component);
        return CommonsTable2Component;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2BodyCellComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2BodyCellComponent, _super);
        function CommonsTable2BodyCellComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommonsTable2BodyCellComponent = __decorate([
            core.Component({
                selector: '[commons-table2-body-cell]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block;text-align:left;box-sizing:border-box;padding:0 16px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-family:Roboto;font-weight:400;font-size:14px;line-height:21px}"]
            })
        ], CommonsTable2BodyCellComponent);
        return CommonsTable2BodyCellComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2BodyRowComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2BodyRowComponent, _super);
        function CommonsTable2BodyRowComponent(root, service) {
            var _this = _super.call(this) || this;
            _this.root = root;
            _this.service = service;
            _this.selectedChange = new core.EventEmitter(true);
            _this.disabled = false;
            return _this;
        }
        CommonsTable2BodyRowComponent.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            this.subscribe(this.service.selectableObservable(this.root), function (selectable) {
                setTimeout(function () { _this.selectable = selectable; }, 0);
            });
            this.selectable = this.service.getSelectable(this.root);
            this.subscribe(this.service.disabledObservable(this.root), function (disabled) {
                setTimeout(function () { _this.disabled = disabled; }, 0);
            });
            this.disabled = this.service.getDisabled(this.root);
            this.subscribe(this.service.columnsChangedObservable(this.root), function (columns) {
                var widths = CommonsTable2Columns.getGridTemplateColumns(columns);
                if (_this.selectable !== undefined)
                    widths = "52px " + widths;
                setTimeout(function () { _this.hostGridTemplateColumns = widths; }, 0);
            });
        };
        CommonsTable2BodyRowComponent.prototype.doSelected = function () {
            this.selectedChange.emit(this.selected);
        };
        CommonsTable2BodyRowComponent.ctorParameters = function () { return [
            { type: CommonsTable2Component },
            { type: CommonsTable2Service }
        ]; };
        __decorate([
            core.HostBinding('style.gridTemplateColumns')
        ], CommonsTable2BodyRowComponent.prototype, "hostGridTemplateColumns", void 0);
        __decorate([
            core.HostBinding('class.selected'), core.Input()
        ], CommonsTable2BodyRowComponent.prototype, "selected", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2BodyRowComponent.prototype, "selectedChange", void 0);
        CommonsTable2BodyRowComponent = __decorate([
            core.Component({
                selector: '[commons-table2-body-row]',
                template: "<td *ngIf=\"this.selectable !== undefined\">\n\t<commons-checkbox\n\t\t\t[disabled]=\"this.disabled\"\n\t\t\t[(checked)]=\"this.selected\"\n\t\t\t(checkedChange)=\"this.doSelected();\"\n\t></commons-checkbox>\n</td>\n<ng-content></ng-content>\n",
                styles: ["@charset 'utf8';:host{display:grid;box-sizing:content-box;padding:6px 0;grid-auto-columns:auto;grid-template-rows:40px;align-items:center}:host-context(body.webappcommons-theme-blue):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-blue).selected{background-color:rgba(122,124,255,.1)}:host-context(body.webappcommons-theme-darkred):hover{background-color:#2a2a2a}:host-context(body.webappcommons-theme-darkred).selected{background-color:rgba(255,81,49,.1)}:host-context(body.webappcommons-theme-hotpink):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-hotpink).selected{background-color:rgba(255,156,229,.1)}:host-context(body.webappcommons-theme-marine):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-marine).selected{background-color:rgba(101,197,224,.1)}:host-context(body.webappcommons-theme-muted):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-muted).selected{background-color:rgba(129,156,169,.1)}:host-context(body.webappcommons-theme-night):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-night).selected{background-color:rgba(143,173,197,.1)}:host-context(body.webappcommons-theme-patrolred):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-patrolred).selected{background-color:rgba(255,81,70,.1)}:host-context(body.webappcommons-theme-purple):hover{background-color:#f2f2f2}:host-context(body.webappcommons-theme-purple).selected{background-color:rgba(191,115,230,.1)}td{display:block;box-sizing:border-box;padding:0 16px}td commons-checkbox{position:relative;top:2px}"]
            })
        ], CommonsTable2BodyRowComponent);
        return CommonsTable2BodyRowComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2FooterComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2FooterComponent, _super);
        function CommonsTable2FooterComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommonsTable2FooterComponent = __decorate([
            core.Component({
                selector: '[commons-table2-footer]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block}"]
            })
        ], CommonsTable2FooterComponent);
        return CommonsTable2FooterComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2FooterPaginationComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2FooterPaginationComponent, _super);
        function CommonsTable2FooterPaginationComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.rowsChange = new core.EventEmitter(true);
            _this.onFirst = new core.EventEmitter(true);
            _this.onBack = new core.EventEmitter(true);
            _this.onForward = new core.EventEmitter(true);
            _this.onLast = new core.EventEmitter(true);
            return _this;
        }
        CommonsTable2FooterPaginationComponent.prototype.doChangeRows = function () {
            this.rowsChange.emit(parseInt(this.internalRows, 10));
        };
        CommonsTable2FooterPaginationComponent.prototype.ngOnChanges = function (_changes) {
            this.internalRows = this.rows === undefined ? undefined : this.rows.toString();
            var thisPageEnd = (this.from || 0) + (this.rows || 0);
            this.canBack = this.rows !== undefined
                && this.from !== undefined
                && this.total
                && this.from > 0;
            this.canForward = this.rows !== undefined
                && this.total
                && thisPageEnd < this.total;
        };
        __decorate([
            core.Input()
        ], CommonsTable2FooterPaginationComponent.prototype, "from", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2FooterPaginationComponent.prototype, "total", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2FooterPaginationComponent.prototype, "rows", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2FooterPaginationComponent.prototype, "rowsChange", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2FooterPaginationComponent.prototype, "onFirst", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2FooterPaginationComponent.prototype, "onBack", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2FooterPaginationComponent.prototype, "onForward", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2FooterPaginationComponent.prototype, "onLast", void 0);
        CommonsTable2FooterPaginationComponent = __decorate([
            core.Component({
                selector: '[commons-table2-footer-pagination]',
                template: "<section container>\n\t<span filler></span>\n\t\n\t<span rows>\n\t\t<label for=\"rows\">Rows per page</label>\n\t\t<commons-textbox class=\"compact inline\"\n\t\t\t\t[options]=\"[ '5', '10', '15', '20' ]\"\n\t\t\t\t[optionsOnly]=\"true\"\n\t\t\t\t[clearable]=\"false\"\n\t\t\t\t[(value)]=\"this.internalRows\"\n\t\t\t\t(valueChange)=\"this.doChangeRows();\"\n\t\t></commons-textbox>\n\t</span>\n\t<span pagination>\n\t\t<ng-container *ngIf=\"this.from !== undefined && this.total !== undefined\">\n\t\t\t{{ this.from + 1 }}&ndash;{{ (this.from + this.rows) >= this.total ? this.total : (this.from + this.rows) }} of {{ this.total }}\n\t\t</ng-container>\n\t</span>\n\t<i class=\"material-icons first\"\n\t\t\t[class.disabled]=\"!this.canBack\"\n\t\t\t(click)=\"this.onFirst.emit();\"\n\t>first_page</i>\n\t<i class=\"material-icons\"\n\t\t\t[class.disabled]=\"!this.canBack\"\n\t\t\t(click)=\"this.onBack.emit();\"\n\t>chevron_left</i>\n\t<i class=\"material-icons\"\n\t\t\t[class.disabled]=\"!this.canForward\"\n\t\t\t(click)=\"this.onForward.emit();\"\n\t>chevron_right</i>\n\t<i class=\"material-icons\"\n\t\t\t[class.disabled]=\"!this.canForward\"\n\t\t\t(click)=\"this.onLast.emit();\"\n\t>last_page</i>\n</section>\n",
                styles: ["@charset 'utf8';:host{display:block;font-family:Roboto;font-weight:400;font-size:14px;line-height:14px}section[container]{width:100%;box-sizing:content-box;padding:6px 0;display:grid;grid-template-columns:1fr auto auto auto auto auto auto;grid-template-rows:40px;align-items:center}section[container] span[rows]{display:grid;grid-template-columns:auto 100px;grid-template-rows:1fr;grid-column-gap:8px;align-items:center;padding:6px 16px;box-sizing:border-box}section[container] span[rows] commons-textbox{position:relative;top:3px}section[container] span[pagination]{display:block;box-sizing:border-box;padding:0 16px}i.material-icons{box-sizing:border-box;padding:0 16px;cursor:pointer}@media only screen and (max-width:619px){section[container]{grid-template-columns:1fr auto auto auto auto auto}section[container] span[pagination]{display:none}i.material-icons{padding-left:0}i.material-icons.first{padding-left:16px}}@media only screen and (max-width:419px){section[container] span[rows]{grid-template-columns:100px}section[container] span[rows] label{display:none}i.material-icons.first{padding-left:0}}:host-context(body.webappcommons-theme-blue) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-darkred) i.material-icons.disabled{color:#4e4e4e;cursor:initial}:host-context(body.webappcommons-theme-hotpink) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-marine) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-muted) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-night) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-patrolred) i.material-icons.disabled{color:#c2c2c2;cursor:initial}:host-context(body.webappcommons-theme-purple) i.material-icons.disabled{color:#c2c2c2;cursor:initial}"]
            })
        ], CommonsTable2FooterPaginationComponent);
        return CommonsTable2FooterPaginationComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2HeaderComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2HeaderComponent, _super);
        function CommonsTable2HeaderComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommonsTable2HeaderComponent = __decorate([
            core.Component({
                selector: '[commons-table2-header]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block}"]
            })
        ], CommonsTable2HeaderComponent);
        return CommonsTable2HeaderComponent;
    }(ngxAngularcommonsCore.CommonsComponent));


    (function (ECommonsTable2Selectable) {
        ECommonsTable2Selectable["SINGLE"] = "single";
        ECommonsTable2Selectable["MULTIPLE"] = "multiple";
    })(exports.ECommonsTable2Selectable || (exports.ECommonsTable2Selectable = {}));
    function toECommonsTable2Selectable(type) {
        switch (type) {
            case exports.ECommonsTable2Selectable.SINGLE.toString():
                return exports.ECommonsTable2Selectable.SINGLE;
            case exports.ECommonsTable2Selectable.MULTIPLE.toString():
                return exports.ECommonsTable2Selectable.MULTIPLE;
        }
        return undefined;
    }
    function fromECommonsTable2Selectable(type) {
        switch (type) {
            case exports.ECommonsTable2Selectable.SINGLE:
                return exports.ECommonsTable2Selectable.SINGLE.toString();
            case exports.ECommonsTable2Selectable.MULTIPLE:
                return exports.ECommonsTable2Selectable.MULTIPLE.toString();
        }
        throw new Error('Unknown ECommonsTable2Selectable');
    }
    function isECommonsTable2Selectable(test) {
        if (!tscommonsCore.CommonsType.isString(test))
            return false;
        return toECommonsTable2Selectable(test) !== undefined;
    }
    function keyToECommonsTable2Selectable(key) {
        switch (key) {
            case 'SINGLE':
                return exports.ECommonsTable2Selectable.SINGLE;
            case 'MULTIPLE':
                return exports.ECommonsTable2Selectable.MULTIPLE;
        }
        throw new Error("Unable to obtain ECommonsTable2Selectable for key: " + key);
    }
    var ɵ0 = function (e) { return keyToECommonsTable2Selectable(e); };
    var ECOMMONS_TABLE2_SELECTABLES = Object.keys(exports.ECommonsTable2Selectable)
        .map(ɵ0);

    var CommonsTable2HeaderColumnsComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2HeaderColumnsComponent, _super);
        function CommonsTable2HeaderColumnsComponent(root, service) {
            var _this = _super.call(this) || this;
            _this.root = root;
            _this.service = service;
            _this.ECommonsTable2Selectable = exports.ECommonsTable2Selectable;
            _this.selectAll = false;
            _this.selectAllChange = new core.EventEmitter(true);
            _this.disabled = false;
            return _this;
        }
        CommonsTable2HeaderColumnsComponent.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            this.subscribe(this.service.selectableObservable(this.root), function (selectable) {
                setTimeout(function () { _this.selectable = selectable; }, 0);
            });
            this.selectable = this.service.getSelectable(this.root);
            this.subscribe(this.service.disabledObservable(this.root), function (disabled) {
                setTimeout(function () { _this.disabled = disabled; }, 0);
            });
            this.disabled = this.service.getDisabled(this.root);
        };
        CommonsTable2HeaderColumnsComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.subscribe(this.contentChildren.changes, function () {
                _this.refreshColumns();
            });
            this.refreshColumns();
        };
        CommonsTable2HeaderColumnsComponent.prototype.refreshColumns = function () {
            var _this = this;
            var columns = CommonsTable2Columns.listColumns(this.contentChildren);
            var widths = CommonsTable2Columns.getGridTemplateColumns(columns);
            if (this.selectable)
                widths = "52px " + widths;
            setTimeout(function () { _this.hostGridTemplateColumns = widths; }, 0);
        };
        CommonsTable2HeaderColumnsComponent.prototype.doSelectAll = function () {
            this.selectAllChange.emit(this.selectAll);
        };
        CommonsTable2HeaderColumnsComponent.ctorParameters = function () { return [
            { type: CommonsTable2Component },
            { type: CommonsTable2Service }
        ]; };
        __decorate([
            core.HostBinding('style.gridTemplateColumns')
        ], CommonsTable2HeaderColumnsComponent.prototype, "hostGridTemplateColumns", void 0);
        __decorate([
            core.ContentChildren(CommonsTable2HeaderColumnComponent)
        ], CommonsTable2HeaderColumnsComponent.prototype, "contentChildren", void 0);
        __decorate([
            core.Input()
        ], CommonsTable2HeaderColumnsComponent.prototype, "selectAll", void 0);
        __decorate([
            core.Output()
        ], CommonsTable2HeaderColumnsComponent.prototype, "selectAllChange", void 0);
        CommonsTable2HeaderColumnsComponent = __decorate([
            core.Component({
                selector: '[commons-table2-header-columns]',
                template: "<td *ngIf=\"this.selectable !== undefined\">\n\t<commons-checkbox *ngIf=\"this.selectable === ECommonsTable2Selectable.MULTIPLE\"\n\t\t\t[disabled]=\"this.disabled\"\n\t\t\t[(checked)]=\"this.selectAll\"\n\t\t\t(checkedChange)=\"this.doSelectAll();\"\n\t></commons-checkbox>\n</td>\n<ng-content></ng-content>\n",
                styles: [":host{display:grid;box-sizing:content-box;padding:6px 0;grid-auto-columns:auto;grid-template-rows:44px;align-items:center}td{display:block;box-sizing:border-box;padding:0 16px}td commons-checkbox{position:relative;top:2px}"]
            })
        ], CommonsTable2HeaderColumnsComponent);
        return CommonsTable2HeaderColumnsComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var CommonsTable2HeaderFilterComponent = /** @class */ (function (_super) {
        __extends(CommonsTable2HeaderFilterComponent, _super);
        function CommonsTable2HeaderFilterComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommonsTable2HeaderFilterComponent = __decorate([
            core.Component({
                selector: '[commons-table2-header-filter]',
                template: "<ng-content></ng-content>\n",
                styles: [":host{display:block}"]
            })
        ], CommonsTable2HeaderFilterComponent);
        return CommonsTable2HeaderFilterComponent;
    }(ngxAngularcommonsCore.CommonsComponent));

    var NgxWebAppCommonsTableModule = /** @class */ (function () {
        function NgxWebAppCommonsTableModule() {
        }
        NgxWebAppCommonsTableModule_1 = NgxWebAppCommonsTableModule;
        NgxWebAppCommonsTableModule.forRoot = function () {
            return {
                ngModule: NgxWebAppCommonsTableModule_1,
                providers: [
                    CommonsTable2Service
                ]
            };
        };
        var NgxWebAppCommonsTableModule_1;
        NgxWebAppCommonsTableModule = NgxWebAppCommonsTableModule_1 = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    ngxAngularcommonsCore.NgxAngularCommonsCoreModule,
                    ngxAngularcommonsBrowser.NgxAngularCommonsBrowserModule,
                    ngxAngularcommonsPipe.NgxAngularCommonsPipeModule,
                    ngxWebappcommonsCore.NgxWebAppCommonsCoreModule,
                    ngxWebappcommonsForm.NgxWebAppCommonsFormModule
                ],
                declarations: [
                    CommonsTable2Component,
                    CommonsTable2HeaderComponent,
                    CommonsTable2HeaderFilterComponent,
                    CommonsTable2HeaderColumnsComponent,
                    CommonsTable2HeaderColumnComponent,
                    CommonsTable2BodyComponent,
                    CommonsTable2BodyRowComponent,
                    CommonsTable2BodyCellComponent,
                    CommonsTable2FooterComponent,
                    CommonsTable2FooterPaginationComponent
                ],
                exports: [
                    CommonsTable2Component,
                    CommonsTable2HeaderComponent,
                    CommonsTable2HeaderFilterComponent,
                    CommonsTable2HeaderColumnsComponent,
                    CommonsTable2HeaderColumnComponent,
                    CommonsTable2BodyComponent,
                    CommonsTable2BodyRowComponent,
                    CommonsTable2BodyCellComponent,
                    CommonsTable2FooterComponent,
                    CommonsTable2FooterPaginationComponent
                ]
            })
        ], NgxWebAppCommonsTableModule);
        return NgxWebAppCommonsTableModule;
    }());

    exports.CommonsTable2BodyCellComponent = CommonsTable2BodyCellComponent;
    exports.CommonsTable2BodyComponent = CommonsTable2BodyComponent;
    exports.CommonsTable2BodyRowComponent = CommonsTable2BodyRowComponent;
    exports.CommonsTable2Component = CommonsTable2Component;
    exports.CommonsTable2FooterComponent = CommonsTable2FooterComponent;
    exports.CommonsTable2FooterPaginationComponent = CommonsTable2FooterPaginationComponent;
    exports.CommonsTable2HeaderColumnComponent = CommonsTable2HeaderColumnComponent;
    exports.CommonsTable2HeaderColumnsComponent = CommonsTable2HeaderColumnsComponent;
    exports.CommonsTable2HeaderComponent = CommonsTable2HeaderComponent;
    exports.CommonsTable2HeaderFilterComponent = CommonsTable2HeaderFilterComponent;
    exports.CommonsTable2Service = CommonsTable2Service;
    exports.ECOMMONS_TABLE2_SELECTABLES = ECOMMONS_TABLE2_SELECTABLES;
    exports.NgxWebAppCommonsTableModule = NgxWebAppCommonsTableModule;
    exports.fromECommonsTable2Selectable = fromECommonsTable2Selectable;
    exports.isECommonsTable2Selectable = isECommonsTable2Selectable;
    exports.keyToECommonsTable2Selectable = keyToECommonsTable2Selectable;
    exports.toECommonsTable2Selectable = toECommonsTable2Selectable;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-webappcommons-table.umd.js.map
