import { OnInit, EventEmitter } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { CommonsTable2Service } from '../../services/commons-table2.service';
import { ECommonsTable2Selectable } from '../../enums/ecommons-table2-selectable';
import { CommonsTable2Component } from '../commons-table2/commons-table2.component';
export declare class CommonsTable2BodyRowComponent extends CommonsComponent implements OnInit {
    private root;
    private service;
    hostGridTemplateColumns: string | undefined;
    selected?: boolean;
    selectedChange: EventEmitter<boolean>;
    selectable: ECommonsTable2Selectable | undefined;
    disabled: boolean;
    constructor(root: CommonsTable2Component, service: CommonsTable2Service);
    ngOnInit(): void;
    doSelected(): void;
}
