import { OnInit, AfterContentInit, OnChanges, SimpleChanges } from '@angular/core';
import { QueryList } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { CommonsTable2Service } from '../../services/commons-table2.service';
import { TCommonsTable2Column } from '../../types/tcommons-table2-column';
import { ECommonsTable2Selectable } from '../../enums/ecommons-table2-selectable';
import { CommonsTable2HeaderColumnComponent } from '../commons-table2-header-column/commons-table2-header-column.component';
import { CommonsTable2BodyComponent } from '../commons-table2-body/commons-table2-body.component';
export declare class CommonsTable2Component extends CommonsComponent implements OnInit, AfterContentInit, OnChanges {
    private service;
    columnsContentChildren: QueryList<CommonsTable2HeaderColumnComponent> | undefined;
    bodyContentChildren: QueryList<CommonsTable2BodyComponent> | undefined;
    selectable: ECommonsTable2Selectable | undefined;
    disabled: boolean;
    constructor(service: CommonsTable2Service);
    columns: TCommonsTable2Column[];
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterContentInit(): void;
    private refreshColumns;
}
