import { Observable } from 'rxjs';
import { CommonsTable2Component } from '../components/commons-table2/commons-table2.component';
import { TCommonsTable2Column } from '../types/tcommons-table2-column';
import { ECommonsTable2Selectable } from '../enums/ecommons-table2-selectable';
export declare class CommonsTable2Service {
    private onColumnsChanged;
    private onSelectable;
    private selectable;
    private onDisabled;
    private disabled;
    registerTable(component: CommonsTable2Component): void;
    columnsChangedObservable(component: CommonsTable2Component): Observable<TCommonsTable2Column[]>;
    cascadeColumnsChanged(component: CommonsTable2Component, columns: TCommonsTable2Column[]): void;
    selectableObservable(component: CommonsTable2Component): Observable<ECommonsTable2Selectable | undefined>;
    cascadeSelectable(component: CommonsTable2Component, selectable: ECommonsTable2Selectable | undefined): void;
    getSelectable(component: CommonsTable2Component): ECommonsTable2Selectable | undefined;
    disabledObservable(component: CommonsTable2Component): Observable<boolean>;
    cascadeDisabled(component: CommonsTable2Component, disabled: boolean): void;
    getDisabled(component: CommonsTable2Component): boolean;
}
