import { OnInit, AfterContentInit, EventEmitter } from '@angular/core';
import { QueryList } from '@angular/core';
import { CommonsComponent } from 'ngx-angularcommons-core';
import { CommonsTable2Service } from '../../services/commons-table2.service';
import { ECommonsTable2Selectable } from '../../enums/ecommons-table2-selectable';
import { CommonsTable2HeaderColumnComponent } from '../commons-table2-header-column/commons-table2-header-column.component';
import { CommonsTable2Component } from '../commons-table2/commons-table2.component';
export declare class CommonsTable2HeaderColumnsComponent extends CommonsComponent implements OnInit, AfterContentInit {
    private root;
    private service;
    ECommonsTable2Selectable: typeof ECommonsTable2Selectable;
    hostGridTemplateColumns: string | undefined;
    contentChildren: QueryList<CommonsTable2HeaderColumnComponent> | undefined;
    selectAll: boolean;
    selectAllChange: EventEmitter<boolean>;
    selectable: ECommonsTable2Selectable | undefined;
    disabled: boolean;
    constructor(root: CommonsTable2Component, service: CommonsTable2Service);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    private refreshColumns;
    doSelectAll(): void;
}
